#include "ADS8688.h"

unsigned short ADS8688_Sample_Init(void)   // ȡͨʾ
{
	uint8_t test;
	uint16_t value;

  ADS8688_RST_PD_H;
  DAISY_IN_L;
  ADS8688_Delay(0x1fff);
  test=ADS8688A_INIT();
  ADS8688_Delay(0x1fff);
  
  ADS8688A_Write_Program_Register(0x02,0x00);//ͨ˳͹״̬
  ADS8688A_Write_Program_Register(0x01,0xff);//ʹͨ
  Set_CH_Range_Select(0X05,0x01);//ͨ0뷶Χ
	
  value = MAN_Ch_n_Mode(MAN_Ch_0);  //

	return value;
}



void ADS8688_Delay(volatile uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}



void AUTO_RST_Mode(void)//Զɨģʽ
{
  ADS8688A_WriteCommandReg(AUTO_RST);
}


void Get_AUTO_RST_Mode_Data(uint16_t* outputdata, uint8_t chnum)
{
  //ȡɨͨеADתcode
  unsigned char i=0,datal=0,datah=0;
  unsigned short data=0;
  for (i=0; i<chnum; i++)
  {
    ADS8688_nCS_L;
		ADS8688_Delay(0x1);
    ADS8688A_SPI_WB(0X00);
    ADS8688A_SPI_WB(0X00);
    datah = ADS8688A_SPI_RB();
    datal = ADS8688A_SPI_RB();
    ADS8688_nCS_H;
		ADS8688_Delay(0x1);
    data = datah<<8 | datal;	//λǰλں
    *(outputdata+i) = data;
  }
}


uint16_t Get_MAN_Ch_n_Mode_Data(void)
{
  unsigned char datah=0,datal=0;
  ADS8688_nCS_L;
  ADS8688A_SPI_WB(0X00);
  ADS8688A_SPI_WB(0X00);
  datah = ADS8688A_SPI_RB();
  datal = ADS8688A_SPI_RB();
  ADS8688_nCS_H;
  return (datah<<8 | datal);
}


void MAN_Ch_n_Mode(uint16_t ch)//ֶģʽ
{
  ADS8688A_WriteCommandReg(ch);	
}

uint8_t ADS8688A_SPI_RB(void)
{
  uint8_t Rdata=0;
 // ADS8688_nCS_L;
	ADS8688_Delay(0x1);
  for(uint8_t s=0;s<8;s++)
  {
    Rdata<<=1;
    ADS8688_SCLK_H;
//		ADS8688_Delay(0x1);
    if(ADS8688_SDO)
    {
      Rdata|=0x01;
    }
    else
    {
      Rdata&=0xFE;
    }
    ADS8688_SCLK_L;
//		ADS8688_Delay(0x1);
  }
  return Rdata;
}


void ADS8688A_SPI_WB(uint8_t com)
{
  uint8_t com_temp=com;
  ADS8688_nCS_L;
	ADS8688_Delay(0x1);
  for(uint8_t s=0;s<8;s++)
  {
    if(com_temp&0x80)
    {
      ADS8688_SDI_H;
		//	ADS8688_Delay(0x1);
    }
    else
    {
      ADS8688_SDI_L;
		//	ADS8688_Delay(0x1);
    }
    ADS8688_SCLK_H;
	//	ADS8688_Delay(0x1);
    com_temp<<=1;
    ADS8688_SCLK_L;
	//	ADS8688_Delay(0x1);
  }
}



void ADS8688A_Write_Program_Register(uint8_t Addr,uint8_t data)
{
  ADS8688_nCS_L;
	ADS8688_Delay(0x1);
  ADS8688A_SPI_WB(Addr<<1| 0X01);
  ADS8688A_SPI_WB(data);
  ADS8688_nCS_H;
	ADS8688_Delay(0x1);
}

void Set_CH_Range_Select(uint8_t ch,uint8_t range) //øͨķΧ
{
  ADS8688A_Write_Program_Register(ch,range);
}



unsigned char ADS8688A_READ_Program_Register(uint8_t Addr)
{
  unsigned char data = 0;
  ADS8688_nCS_L;
	ADS8688_Delay(0x1);
  ADS8688A_SPI_WB(Addr<<1);
  data = ADS8688A_SPI_RB();
  data = ADS8688A_SPI_RB();
  ADS8688_nCS_H;
	ADS8688_Delay(0x1);
  return data;
}

void Enter_RESET_MODE(void)//λģʽλ program registers
{
  ADS8688A_WriteCommandReg(RST);
}

void ADS8688A_WriteCommandReg(uint16_t command)//дADS8688Ĵ
{
  ADS8688_nCS_L;
	ADS8688_Delay(0x1);
  ADS8688A_SPI_WB(command>>8 & 0XFF);
  ADS8688A_SPI_WB(command & 0XFF);
  ADS8688_nCS_H;
	ADS8688_Delay(0x1);
}

uint8_t ADS8688A_INIT(void)
{
  uint8_t i;
  Enter_RESET_MODE();
  ADS8688A_Write_Program_Register(0X01,0XFF);
  i = ADS8688A_READ_Program_Register(0X01);
  return i;
}









